## mx-samba-config 0.21.12.01

=== debian/changelog ===
mx-samba-config (0.21.12.01) mx; urgency=medium

  * Version bump. Changes listed in github repo

 -- Adrian <adrian@mxlinux.org>  Sun, 26 Dec 2021 21:06:18 -0500

mx-samba-config (0.21.12) mx; urgency=medium

  * Initial build

 -- Adrian <adrian@mxlinux.org>  Thu, 16 Dec 2021 19:14:52 -0500

## mx-samba-config 0.21.12.03

=== debian/changelog ===
mx-samba-config (0.21.12.03) mx; urgency=medium

  * Add busy indicator when starting/stopping/enabling Samba

 -- Adrian <adrian@mxlinux.org>  Thu, 30 Dec 2021 18:27:46 -0500

mx-samba-config (0.21.12.02) mx; urgency=medium

  * Check if user is part of smabashare group (needed for MX-19 and RPi versions)

 -- Adrian <adrian@mxlinux.org>  Thu, 30 Dec 2021 12:00:13 -0500

## mx-samba-config 25.11

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2017-2025 MX Authors
# *
# * Authors: Adrian
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of mx-samba-config.
# *
# * mx-samba-config is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * mx-samba-config is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with mx-samba-config.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

# Option to use clang for testing builds - needs to be early so project() picks it up
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang CACHE STRING "C compiler" FORCE)
    set(CMAKE_CXX_COMPILER clang++ CACHE STRING "C++ compiler" FORCE)
    message(STATUS "Using clang compiler")
endif()

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

# Fallback to a safe default when changelog parsing is unavailable
if(NOT DPKG_RESULT EQUAL 0 OR PROJECT_VERSION_FROM_CHANGELOG STREQUAL "")
    message(WARNING "Falling back to version 0.0.0 (dpkg-parsechangelog not available or failed)")
    set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
endif()

project(mx-samba-config
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "Samba configuration tool for MX Linux"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
if(USE_CLANG)
    set(CMAKE_CXX_COMPILER_ID "Clang")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    src/main.cpp
    src/mainwindow.cpp
    src/editshare.cpp
    src/about.cpp
)

set(HEADERS
    src/mainwindow.h
    src/editshare.h
    src/about.h
)

set(UI_FILES
    src/mainwindow.ui
    src/editshare.ui
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(mx-samba-config
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(mx-samba-config
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

# Set compiler flags
target_compile_options(mx-samba-config PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(mx-samba-config PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(mx-samba-config PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(mx-samba-config PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
    VERSION="${PROJECT_VERSION}"
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(mx-samba-config PRIVATE NDEBUG)
    target_compile_options(mx-samba-config PRIVATE -O3)

    # Add LTO - different flags for different compilers
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(mx-samba-config PRIVATE -flto=thin)
        target_link_options(mx-samba-config PRIVATE -flto=thin)
    else()
        target_compile_options(mx-samba-config PRIVATE -flto=auto)
        target_link_options(mx-samba-config PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(mx-samba-config
    TS_FILES ${TRANSLATION_FILES}
    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
    QM_FILES_OUTPUT_VARIABLE qm_files
)

# Set target properties
set_target_properties(mx-samba-config PROPERTIES
    OUTPUT_NAME "mx-samba-config"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Install target (required by Debian build system)
# Other files are handled by debian/install
install(TARGETS mx-samba-config
    RUNTIME DESTINATION bin
)

## mx-samba-config 0.21.12.04

=== debian/changelog ===
mx-samba-config (0.21.12.04) mx; urgency=medium

  * Fix: adding samba share if guest_ok=n
  * Display error message in case it fails to add share
  * Some performances fixes, noticeable mostly on Raspberry Pi

 -- Adrian <adrian@mxlinux.org>  Fri, 31 Dec 2021 16:06:22 -0500

=== debian/control ===
Source: mx-samba-config
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8

Package: mx-samba-config
Architecture: any
Depends: xdg-utils | mx-viewer, 
         samba,
         ${misc:Depends}, 
         ${shlibs:Depends}
Description: mx-samba-config
 mx-samba-config

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	lrelease src.pro
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/#define VERSION \"\1\"/" > version.h
	dh_auto_build

# Uncomment if building in Virtual Box
override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym --parallel

## mx-samba-config 22.1

=== debian/changelog ===
mx-samba-config (22.1) mx; urgency=medium

  * First official release with translations

 -- Adrian <adrian@mxlinux.org>  Sat, 29 Jan 2022 14:22:36 -0500

## mx-samba-config 22.3

=== debian/changelog ===
mx-samba-config (22.1.01) mx; urgency=medium

  * 'Everyone' in the command should not be translated

 -- Adrian <adrian@mxlinux.org>  Sun, 30 Jan 2022 18:51:14 -0500

## mx-samba-config 22.4

=== debian/changelog ===
mx-samba-config (22.4) mx; urgency=medium

  * update postinstall, don't setup group if already exists

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Fri, 01 Apr 2022 22:37:53 -0400

mx-samba-config (22.3) mx; urgency=medium

  * adjust postinstall 

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sun, 27 Mar 2022 14:36:23 -0400

## mx-samba-config 22.7

=== debian/changelog ===
mx-samba-config (22.7) mx; urgency=medium

  * translation refresh 

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sat, 23 Jul 2022 12:29:43 -0400

## mx-samba-config 22.8

=== debian/changelog ===
mx-samba-config (22.8) mx; urgency=medium

  * Fix adding user

 -- Adrian <adrian@mxlinux.org>  Wed, 10 Aug 2022 21:23:46 -0400

## mx-samba-config 22.10

=== debian/changelog ===
mx-samba-config (22.10) mx; urgency=medium

  * translation refresh

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Wed, 26 Oct 2022 20:06:39 -0400

## mx-samba-config 23.03

=== debian/changelog ===
mx-samba-config (23.03) mx; urgency=medium

  * update translations

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Wed, 08 Mar 2023 22:52:25 -0500

## mx-samba-config 23.5

=== debian/changelog ===
mx-samba-config (23.5) mx; urgency=medium

  * Update logo

 -- Adrian <adrian@mxlinux.org>  Wed, 17 May 2023 22:43:51 -0400

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 	rm -f src/translations/*.qm
 
 override_dh_auto_build:
-	lrelease src.pro
+	lrelease translations/*.ts
 	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/#define VERSION \"\1\"/" > version.h
 	dh_auto_build

## mx-samba-config 23.7

=== debian/changelog ===
mx-samba-config (23.7) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Thu, 20 Jul 2023 17:08:28 -0400

## mx-samba-config 23.12

=== debian/changelog ===
mx-samba-config (23.12) mx; urgency=medium

  * Fix about window title

 -- Adrian <adrian@mxlinux.org>  Fri, 08 Dec 2023 10:51:20 -0500

## mx-samba-config 24.3

=== debian/changelog ===
mx-samba-config (24.3) mx; urgency=medium

  * Update translations 

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 12:59:21 -0400

mx-samba-config (23.12.02) mx; urgency=medium

  * Small fix: run both update-rc.d and systemctl on MX

 -- Adrian <adrian@mxlinux.org>  Fri, 08 Dec 2023 21:41:57 -0500

mx-samba-config (23.12.01) mx; urgency=medium

  * Generalize: don't assume service command available

 -- Adrian <adrian@mxlinux.org>  Fri, 08 Dec 2023 19:55:17 -0500

=== debian/control ===
--- 
+++ 
@@ -11,5 +11,8 @@
          samba,
          ${misc:Depends}, 
          ${shlibs:Depends}
-Description: mx-samba-config
- mx-samba-config
+Description: GUI for managing Samba shares and users
+ Samba configuration tool designed to work with the same samba “usershare” 
+ system used by the thunar-shares-plugin and Dolphin file sharing capabilities. 
+ It provides the ability for users to set up samba shares for folders they own, 
+ as well as add and remove samba users.

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 override_dh_auto_build:
 	lrelease translations/*.ts
-	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/#define VERSION \"\1\"/" > version.h
+	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/const QString VERSION {\"\1\"};/" > version.h
 	dh_auto_build
 
 # Uncomment if building in Virtual Box

## mx-samba-config 24.4

=== debian/changelog ===
mx-samba-config (24.4) mx; urgency=medium

  * Update to Qt6

 -- Adrian <adrian@mxlinux.org>  Thu, 24 Apr 2025 14:31:08 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
+Build-Depends: debhelper (>=10), qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
 Standards-Version: 3.9.8
 
 Package: mx-samba-config

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake6 QMAKE_OPTS="$(QMAKE_OPTS)"

override_dh_auto_configure:
	qmake6

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	/usr/lib/qt6/bin/lrelease translations/*.ts
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/const QString VERSION {\"\1\"};/" > version.h
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym --parallel

## mx-samba-config 25.11

=== debian/changelog ===
mx-samba-config (25.11) mx; urgency=medium

  * Various fixes
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Wed, 05 Nov 2025 23:48:57 -0500

## mx-samba-config 25.11.1

=== debian/changelog ===
mx-samba-config (25.11.1) mx; urgency=medium

  * Fix displaying version in About menu

 -- Adrian <adrian@mxlinux.org>  Fri, 07 Nov 2025 21:01:26 -0500

=== debian/control ===
Source: mx-samba-config
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (=12), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/MX-Linux/mx-samba-config
Homepage: https://github.com/MX-Linux/mx-samba-config

Package: mx-samba-config
Architecture: any
Depends: mx-viewer | xdg-utils,
         samba,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Samba configuration tool for MX Linux
 MX Samba Config is a graphical utility that allows users to easily
 manage Samba shares and users. It provides a user-friendly interface for:
  * Setting up Samba shares for folders owned by the user
  * Adding and removing Samba users
  * Working with the same "usershare" system used by Thunar and Dolphin
  * Configuring share permissions and visibility options

## mx-samba-config 25.12

=== debian/changelog ===
mx-samba-config (25.12) mx; urgency=medium

  * Validate share permission selection before saving

 -- Adrian <adrian@mxlinux.org>  Tue, 02 Dec 2025 11:48:47 -0500

## mx-samba-config 25.12.1

=== debian/changelog ===
mx-samba-config (25.12.1) mx; urgency=medium

  * Updated share permissions handling: the dialog now only requires at
    least one selected access across all users (Everyone can stay
    unset).
  * Permission strings are built with a joined list to avoid
    malformed ACLs when only specific entries are chosen.

 -- Adrian <adrian@mxlinux.org>  Wed, 03 Dec 2025 14:18:20 -0500

## mx-samba-config 25.12.3

=== debian/changelog ===
mx-samba-config (25.12.3) mx; urgency=medium

  * Require Samba user before adding share

 -- Adrian <adrian@mxlinux.org>  Sun, 07 Dec 2025 23:43:46 -0500
